## checkit-tiff 0.2.3

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (checkit_tiff)
include_directories("${PROJECT_SOURCE_DIR}/headers")
include_directories("${PROJECT_SOURCE_DIR}/validate_icc")
include (CheckSymbolExists)
include (CheckFunctionExists)

file( GLOB checkit_tiff_SOURCES 
  "${PROJECT_SOURCE_DIR}/tagrules/*.c"
  "${PROJECT_SOURCE_DIR}/ifdrules/*.c"
  "${PROJECT_SOURCE_DIR}/helper/*.c"
  "${PROJECT_SOURCE_DIR}/parser/*parser.c"
  "${PROJECT_SOURCE_DIR}/validate_icc/*.c"
  "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
  )

file( GLOB checkit_tiff_risk_SOURCES
  "${PROJECT_SOURCE_DIR}/helper/*.c"
  "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
)

#
# Make a version file containing the current version from git.
#
execute_process( COMMAND git rev-list HEAD --count OUTPUT_VARIABLE REPO_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE )
execute_process( COMMAND git rev-parse --abbrev-ref HEAD OUTPUT_VARIABLE BUILD_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process( COMMAND git rev-parse HEAD OUTPUT_VARIABLE BUILD_REV_ID OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process( COMMAND git describe --long --tags --dirty --always OUTPUT_VARIABLE BUILD_REV_ID_SHORT OUTPUT_STRIP_TRAILING_WHITESPACE)
add_definitions(-DVERSION="${BUILD_BRANCH}")
add_definitions(-DREPO_REVISION="${REPO_REVISION}")
add_definitions(-std=gnu11)
if(WIN32)
  add_definitions(-D__WIN32__=1)
  SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  SET(BUILD_SHARED_LIBRARIES OFF)
  # needed to increase default stack, because Win7 has only 1MB
  SET(CMAKE_EXE_LINKER_FLAGS "-static -Wl,--stack,20000000")
  add_definitions(-DPCRE_STATIC)
  add_definitions(-D_POSIX_C_SOURCE=200809L)
  # FIXME: needed for MingW only
  add_definitions(-D_GNU_SOURCE=1)
endif(WIN32)

add_executable(checkit_tiff checkit_tiff.c ${checkit_tiff_SOURCES})
add_executable(checkit_check_config checkit_check_config.c ${checkit_tiff_SOURCES})
add_executable(checkit_tiff_risk checkit_tiff_risk.c ${checkit_tiff_risk_SOURCES})
set(CMAKE_EXTRA_INCLUDE_FILES tiff.h)


#libpcre
#find_package(LIBPCRE REQUIRED)
FIND_PATH(PCRE_INCLUDE_DIR NAMES pcre.h)
FIND_LIBRARY(PCRE_LIBRARY NAMES pcre)
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(PCRE DEFAULT_MSG PCRE_LIBRARY PCRE_INCLUDE_DIR)
if (PCRE_FOUND)
  SET(PCRE_LIBRARIES ${PCRE_LIBRARY})
  SET(PCRE_INCLUDE_DIRS ${PCRE_INCLUDE_DIR})
  INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIR})
else(PCRE_FOUND)
  MESSAGE(FATAL_ERROR "No PCRE library found, add $PCRE_INCLUDE_DIR manually")
endif(PCRE_FOUND)

#find mmap
CHECK_FUNCTION_EXISTS(mmap   _HAVE_MMAP)
CHECK_FUNCTION_EXISTS(munmap _HAVE_MUNMAP)
IF(_HAVE_MMAP AND _HAVE_MUNMAP)
  MESSAGE(INFO "mmap found")
  SET(_HAVE__MMAP 1)
ENDIF()



TARGET_LINK_LIBRARIES(checkit_tiff ${PCRE_LIBRARIES})
TARGET_LINK_LIBRARIES(checkit_check_config ${PCRE_LIBRARIES})
TARGET_LINK_LIBRARIES(checkit_tiff_risk)

install( TARGETS checkit_tiff
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
)
install(DIRECTORY 
  ../example_configs
  ../tiffs_should_fail
  ../tiffs_should_pass 
  DESTINATION share/checkit_tiff/
)

file( GLOB README_FILES "../README*" "../FAQ" "../LICENSE" "../TODO" "../BUGS")
install(FILES ${README_FILES} DESTINATION share/checkit_tiff/)

=== debian/changelog ===
checkit-tiff (0.2.3-2) unstable; urgency=medium

  * Team upload.
  * Add missing copyright
    Closes: #854769
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Tue, 20 Feb 2018 21:00:43 +0100

checkit-tiff (0.2.3-1) unstable; urgency=medium

  * Initial release
    Closes: #830293

 -- Andreas Romeyke <art1@andreas-romeyke.de>  Sun, 05 Feb 2017 21:20:37 +0100

=== debian/control ===
Source: checkit-tiff
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Andreas Romeyke <art1@andreas-romeyke.de>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               libpcre3-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/checkit-tiff.git
Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/checkit-tiff.git
Homepage: https://github.com/SLUB-digitalpreservation/checkit_tiff

Package: checkit-tiff
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: conformance checker for baseline TIFFs
 "checkit_tiff" is a conformance checker for baseline TIFFs (with various
 extensions). It works in different way than other tools. Instead to use
 a hardcoded rule set with predefined values, you are able to define tags
 and corresponding values more fine granulary. The rulesets are human
 readable and could be adapted to own needs.
 .
 The "checkit_tiff" works on commandline and therefore it is embedable
 in scripts
 .
 The tools are developed for purposes of curation and longterm
 preservation

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory=src --buildsystem=cmake

override_dh_install:
	dh_install
	find debian -name "LICENSE" -delete

=== debian/watch ===
version=3

https://github.com/SLUB-digitalpreservation/checkit_tiff/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## checkit-tiff 0.4.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,14 +8,19 @@
 file( GLOB checkit_tiff_SOURCES 
   "${PROJECT_SOURCE_DIR}/tagrules/*.c"
   "${PROJECT_SOURCE_DIR}/ifdrules/*.c"
+  "${PROJECT_SOURCE_DIR}/messages/*.c"
   "${PROJECT_SOURCE_DIR}/helper/*.c"
+  "${PROJECT_SOURCE_DIR}/helper/renderer/*.c"
   "${PROJECT_SOURCE_DIR}/parser/*parser.c"
   "${PROJECT_SOURCE_DIR}/validate_icc/*.c"
   "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
   )
 
 file( GLOB checkit_tiff_risk_SOURCES
-  "${PROJECT_SOURCE_DIR}/helper/*.c"
+  "${PROJECT_SOURCE_DIR}/helper/check_helper.c"
+  "${PROJECT_SOURCE_DIR}/helper/check_print.c"
+  "${PROJECT_SOURCE_DIR}/helper/check_tiffparse.c"
+  "${PROJECT_SOURCE_DIR}/messages/*.c"
   "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
 )
 
@@ -24,11 +29,22 @@
 #
 execute_process( COMMAND git rev-list HEAD --count OUTPUT_VARIABLE REPO_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE )
 execute_process( COMMAND git rev-parse --abbrev-ref HEAD OUTPUT_VARIABLE BUILD_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
+execute_process( COMMAND git describe --tags OUTPUT_VARIABLE BUILD_TAG OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process( COMMAND git rev-parse HEAD OUTPUT_VARIABLE BUILD_REV_ID OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process( COMMAND git describe --long --tags --dirty --always OUTPUT_VARIABLE BUILD_REV_ID_SHORT OUTPUT_STRIP_TRAILING_WHITESPACE)
-add_definitions(-DVERSION="${BUILD_BRANCH}")
+add_definitions(-DVERSION="${BUILD_BRANCH}_${BUILD_TAG}")
 add_definitions(-DREPO_REVISION="${REPO_REVISION}")
-add_definitions(-std=gnu11)
+
+# Check for compatibility with gnu11
+# Compile with gnu11 support.
+include(CheckCCompilerFlag)
+CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_GNU11)
+if(COMPILER_SUPPORTS_GNU11)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
+else()
+    message(STATUS "Your compiler (${CMAKE_C_COMPILER}) has no gnu11 support. If you are using clang on Apple OS X, please switch to gcc (version > 4.7) which is compliant with the C11 standard.")
+endif()
+
 if(WIN32)
   add_definitions(-D__WIN32__=1)
   SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")

=== src/Makefile ===
# rule based checks if given TIFF is a specific baseline TIFF
# author: Andreas Romeyke, 2015
# licensed under conditions of libtiff 
# (see http://libtiff.maptools.org/misc.html)

### needs libtiff (>= v4)
###       libpcre (>=v3)

LIB+=-lpcre -ltiff -lm
SANITIZE?=-fsanitize=undefined -fsanitize=shift \
-fsanitize=integer-divide-by-zero -fsanitize=unreachable \
-fsanitize=vla-bound -fsanitize=null -fsanitize=return \
-fsanitize=signed-integer-overflow 
#-fsanitize=leak
CFLAGS?= -g -Wall $(SANITIZE)
GRAMMAR=parser/config_dsl.grammar.c
SRCS=$(wildcard tagrules/*.c) $(wildcard ifdrules/*.c) $(wildcard helper/*.c) $(wildcard parser/*parser.c)
OBJS=$(patsubst %.c,%.o, $(SRCS))
CFLAGS+=-I headers/

# default target
all: checkit_tiff checkit_check_config

# remove debugging symbols (smaller size)
strip: all
	strip --strip-all checkit_tiff

parser/config_parser.c: parser/config_dsl.grammar.c

parser/config_dsl.grammar.c: parser/config_dsl.grammar.peg

%.o: %.c
	$(CC) $(CFLAGS) $(INC) -c $< -o $@

# produce parser via PEG
%.c: %.peg
	peg $< > $@

-include version.mk

checkit_tiff.o: checkit_tiff.c
	$(CC) -DVERSION="\"$(BUILD_BRANCH)\"" -DREPO_REVISION="\"0.$(REPO_REVISION)\""  $(CFLAGS) $(INC) -c $< -o $@

# default executable
checkit_tiff: $(OBJS) checkit_tiff.o
	$(CC) -o $@ $(CFLAGS) $(INC) $^ $(LIB)

checkit_check_config: $(OBJS) checkit_check_config.o
	$(CC) -o $@ $(CFLAGS) $(INC) $^ $(LIB)

checkit_check_config.c: $(GRAMMAR)

# doc
doc: ../common/doxygen.conf
	@doxygen ../common/doxygen.conf

# clean workdir
clean:
	@rm -f *.o $(OBJS)
	@rm -f checkit_tiff checkit_check_config

# mrproper clean
distclean: clean
	@find ./ -name "*~" -exec rm -f \{\} \;
	@rm -f core
	@rm -Rf doc/
	@rm -f .depend
	@rm -f *.d
	@rm -f .depend


#depend: .depend

#.depend: $(SRCS)
#	rm -f ./.depend
#	echo $^
#	$(CC) $(CFLAGS) -MM $^>>./.depend;

#-include .depend

.PHONY: all clean distclean strip depend

=== debian/changelog ===
checkit-tiff (0.4.2-1) unstable; urgency=medium

  * Team upload.
  * Fix Vcs fields
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * No tab in license text (routine-update)
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 26 Aug 2021 10:45:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Uploaders: Andreas Romeyke <art1@andreas-romeyke.de>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libpcre3-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/checkit-tiff.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/checkit-tiff.git
+Standards-Version: 4.6.0
+Vcs-Browser: https://salsa.debian.org/debian-phototools-team/checkit-tiff
+Vcs-Git: https://salsa.debian.org/debian-phototools-team/checkit-tiff.git
 Homepage: https://github.com/SLUB-digitalpreservation/checkit_tiff
+Rules-Requires-Root: no
 
 Package: checkit-tiff
 Architecture: any

=== debian/watch ===
version=4

https://github.com/SLUB-digitalpreservation/checkit_tiff/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## checkit-tiff 1.4.4

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9.4)
project (checkit_tiff)
include_directories("${PROJECT_SOURCE_DIR}/headers")
include_directories("${PROJECT_SOURCE_DIR}/lib/include")

include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckIPOSupported)
include(CheckCCompilerFlag)

file( GLOB checkit_tiff_SOURCES
  "${PROJECT_SOURCE_DIR}/tagrules/*.c"
  "${PROJECT_SOURCE_DIR}/ifdrules/*.c"
  "${PROJECT_SOURCE_DIR}/messages/*.c"
  "${PROJECT_SOURCE_DIR}/helper/*.c"
  "${PROJECT_SOURCE_DIR}/helper/renderer/*.c"
  "${PROJECT_SOURCE_DIR}/parser/*parser.c"
  "${PROJECT_SOURCE_DIR}/validate_icc/*.c"
  "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
  )

file( GLOB checkit_tiff_risk_SOURCES
  "${PROJECT_SOURCE_DIR}/helper/check_helper.c"
  "${PROJECT_SOURCE_DIR}/helper/check_print.c"
  "${PROJECT_SOURCE_DIR}/helper/check_tiffparse.c"
  "${PROJECT_SOURCE_DIR}/messages/*.c"
  "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
  )

#
# Make a version file containing the current version from git.
#
execute_process( COMMAND git rev-list HEAD --count OUTPUT_VARIABLE REPO_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE )
execute_process( COMMAND git rev-parse --abbrev-ref HEAD OUTPUT_VARIABLE BUILD_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process( COMMAND git describe --tags OUTPUT_VARIABLE BUILD_TAG OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process( COMMAND git rev-parse HEAD OUTPUT_VARIABLE BUILD_REV_ID OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process( COMMAND git describe --long --tags --dirty --always OUTPUT_VARIABLE BUILD_REV_ID_SHORT OUTPUT_STRIP_TRAILING_WHITESPACE)
add_definitions(-DVERSION="${BUILD_BRANCH}_${BUILD_TAG}")
add_definitions(-DREPO_REVISION="${REPO_REVISION}")
add_definitions(-D_GNU_SOURCE)

check_ipo_supported(RESULT LTO_IS_SUPPORTED OUTPUT LTO_CHECK_ERROR)
if (LTO_IS_SUPPORTED)
  message(STATUS "IPO / LTO enabled")
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
else()
  message(STATUS "IPO / LTO unsupported: <${LTO_CHECK_ERROR}>")
endif()

# add default CFLAGS
if(CMAKE_COMPILER_IS_GNUCC)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat -Werror=format-security -ffunction-sections -fdata-sections")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat -Werror=format-security -ffunction-sections -fdata-sections")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
endif()

set(CMAKE_OPTIMIZE_DEPENDENCIES TRUE)
CHECK_C_COMPILER_FLAG("-fstack-protector-strong" COMPILER_SUPPORTS_STACKPROTECTOR )
if(COMPILER_SUPPORTS_STACKPROTECTOR)
  if (EMSCRIPTEN)
  elseif()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong")
  endif()
else()
  message(STATUS "Your compiler (${CMAKE_C_COMPILER}) has no strong stack protector functionality.")
endif()

# Check for compatibility with gnu11
# Compile with gnu11 support.

CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_GNU11)

if(COMPILER_SUPPORTS_GNU11)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
else()
  message(STATUS "Your compiler (${CMAKE_C_COMPILER}) has no gnu11 support.")
  message(STATUS "If you are using clang on Apple OS X, please switch to gcc (version > 4.7) which is compliant with the C11 standard.")
  message(STATUS "If you are using MinGW or compile under MS Windows, the code could compile, but without any warranty and without any support!")
endif()

# we need reallocarray support, which  is not available in all versions of glibc
# COMPACT_NEED_REALLOCARRAY to be set
INCLUDE(CheckCSourceCompiles)
CHECK_C_SOURCE_COMPILES(
        "
#define _GNU_SOURCE
#include <stdlib.h>
int main(void)
{
        return !!reallocarray(NULL, 1, 1);
}
" HAVE_REALLOCARRAY_SUPPORT)
if (HAVE_REALLOCARRAY_SUPPORT)
  message(STATUS "Your compiler (${CMAKE_C_COMPILER}) has reallocarray support, fine :)")
  set(CMAKE_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
else()
  message(STATUS "You compiler (${CMAKE_C_COMPILER}) has no reallocarray support, using workaround.")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCOMPAT_NEED_REALLOCARRAY")
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)


if(WIN32)
  add_definitions(-D__WIN32__=1)
  set(STATIC 1)
  # needed to increase default stack, because Win7 has only 1MB
  set(CMAKE_EXE_LINKER_FLAGS "-Wl,--stack,20000000")
  add_definitions(-D_POSIX_C_SOURCE=200809L)
  # FIXME: needed for MingW only
  add_definitions(-D_GNU_SOURCE=1)
  message(STATUS "target WIN32 detected.")
endif()

if(EMSCRIPTEN_WEB)
  message(STATUS "found EMSCRIPTEN_WEB, enabling singlemode for web")
  set(STATIC 1)
  set(EMSCRIPTEN_OPTS "-s SINGLE_FILE=1 -s RUNTIME_LOGGING=1 -s EXIT_RUNTIME=1 -s INVOKE_RUN=0 -U_FORTIFY_SOURCE -s LLD_REPORT_UNDEFINED -s INITIAL_MEMORY=24051712 -s ALLOW_MEMORY_GROWTH")
  # file(REAL_PATH ${PROJECT_SOURCE_DIR}/../example_configs EMBED_DIR)
  #get_filename_component(EMBED_DIR "${PROJECT_SOURCE_DIR}/../example_configs" REALPATH)
  set(EMBED_DIR "../example_configs")
  message(STATUS "set EMBED_DIR to ${EMBED_DIR}")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EMSCRIPTEN_OPTS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EMSCRIPTEN_OPTS}")
  set(CMAKE_C_LINK_EXECUTABLE "${CMAKE_C_LINK_EXECUTABLE} --embed-file \"${EMBED_DIR}\"@/ -lidbfs.js")
  set(CMAKE_CXX_LINK_EXECUTABLE "${CMAKE_CXX_LINK_EXECUTABLE} --embed-file \"${EMBED_DIR}\"@/ -lidbfs.js")
elseif(EMSCRIPTEN)
  message(STATUS "found EMSCRIPTEN, enabling singlemode")
  set(STATIC 1)
  set(EMSCRIPTEN_OPTS "-s SINGLE_FILE=1 -s RUNTIME_LOGGING=1 -s EXIT_RUNTIME=1 -U_FORTIFY_SOURCE -s LLD_REPORT_UNDEFINED -s INITIAL_MEMORY=24051712 -s ALLOW_MEMORY_GROWTH -s NODERAWFS=1")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EMSCRIPTEN_OPTS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EMSCRIPTEN_OPTS}")
  set(CMAKE_C_LINK_EXECUTABLE "${CMAKE_C_LINK_EXECUTABLE} -lnodefs.js -lnoderawfs.js")
  set(CMAKE_CXX_LINK_EXECUTABLE "${CMAKE_C_LINK_EXECUTABLE} -lnodefs.js -lnoderawfs.js")
else()
  message(STATUS "enabling relro PIE linker flags")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
endif()

if(STATIC)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  set(BUILD_SHARED_LIBRARIES OFF)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
  add_definitions(-DPCRE2_STATIC)
  message(STATUS "STATIC compilation requested.")
endif()


add_executable(checkit_tiff checkit_tiff.c ${checkit_tiff_SOURCES})
add_executable(checkit_check_config checkit_check_config.c ${checkit_tiff_SOURCES})
add_executable(checkit_tiff_risk checkit_tiff_risk.c ${checkit_tiff_risk_SOURCES})
set(CMAKE_EXTRA_INCLUDE_FILES tiff.h)
#libpcre2
message(STATUS "check if PCRE_DIR exists, otherwise standard pkgconfig is used")
if (PCRE2_INCLUDE_DIR AND PCRE2_LIBRARY AND PCRE2_POSIX_LIBRARY)
  include(FindPackageHandleStandardArgs)
  FIND_PACKAGE_HANDLE_STANDARD_ARGS(PCRE2 DEFAULT_MSG PCRE2_LIBRARY PCRE2_POSIX_LIBRARY PCRE2_INCLUDE_DIR)
  set(PCRE2_LIBRARIES ${PCRE2_POSIX_LIBRARY} ${PCRE2_LIBRARY} )
  set(PCRE2_INCLUDE_DIRS ${PCRE2_INCLUDE_DIR})
  get_filename_component(PCRE2_LIBDIR ${PCRE2_LIBRARY} DIRECTORY)
  get_filename_component(PCRE2_LIBRARY_CALC ${PCRE2_LIBRARY} NAME_WE)
  get_filename_component(PCRE2_POSIXLIBRARY_CALC ${PCRE2_POSIX_LIBRARY} NAME_WE)
  set(PCRE2_LDFLAGS "-L ${PCRE2_LIBDIR};-l${PCRE2_LIBRARY_CALC};-l${PCRE2_POSIX_LIBRARY_CALC}")
  set(PCRE2_STATIC_LDFLAGS "-L ${PCRE2_LIBDIR};-lpcre2-8")
  set(PCRE2_FOUND 1)
else()
  find_package(PkgConfig)
  if(PkgConfig_FOUND)
    pkg_check_modules(PCRE2 libpcre2-8)
  endif()
endif()
if (PCRE2_FOUND)
  add_compile_definitions(USE_LIBPCRE2)
  include_directories(${PCRE2_INCLUDE_DIRS})
  find_package_message(PCRE2 "found PCRE2" "[${PCRE2_INCLUDE_DIRS}][${PCRE2_LIBRARIES}][${PCRE2_STATIC_LIBRARY}]")
  get_cmake_property(_variableNames VARIABLES)
  message("STATUS pcre compile static: ${PCRE2_STATIC_LIBRARIES}")
else()
  message(FATAL_ERROR " No PCRE2 library found, add $PCRE2_INCLUDE_DIRS and $PCRE2_LIBRARIES manually")
endif()

#find mmap
CHECK_FUNCTION_EXISTS(mmap   HAVE_MMAP)
CHECK_FUNCTION_EXISTS(munmap HAVE_MUNMAP)
if(HAVE_MMAP AND HAVE_MUNMAP)
  set(HAVE__MMAP 1)
  add_definitions(-DHAVE_MMAP)
endif()

# find strndup
CHECK_FUNCTION_EXISTS(strndup HAVE_STRNDUP)
if (NOT HAVE_STRNDUP)
  message(WARNING "You compiler (${CMAKE_C_COMPILER}) has no strndup support, using workaround.")
endif()

#find IccProfLib, a part of DemoIccMAX, a reference implementation of International Color Consortium (https://github.com/InternationalColorConsortium/DemoIccMAX)
message(STATUS "checking IccProflib2")
find_package(RefIccMAX)
if( WITHOUT_ICC_PROFLIB)
    unset(RefIccMAX_FOUND)
endif()
if (RefIccMAX_FOUND)
  message(STATUS "found RefIccMAX include ${REFICCMAX_INCLUDE_DIR}")
  add_definitions(-DHAVE_IccProfLib)
  include_directories(${REFICCMAX_INCLUDE_DIR})
  include_directories("${REFICCMAX_INCLUDE_DIR}/IccProfLib2")
  message(STATUS "found RefIccMAX libraries ${REFICCMAX_LIBRARIES}")
  message(STATUS "found RefIccMAX static library  ${REFICCMAX_STATIC_LIBRARY}")
else()
    message(STATUS "no IccProfLib found, disabled full ICC profile checking")
    message(VERBOSE "the IccProfLib is available at https://github.com/InternationalColorConsortium/DemoIccMAX")
endif()
#find_path(IccProfLib_INCLUDE_DIR NAMES IccProfileHeader.h)
#find_library(IccProfLib_LIBRARY NAMES libIccProfLib2  HINTS "{CMAKE_PREFIX_PATH}/lib" "{CMAKE_PREFIX_PATH}/.libs" )
#if (IccProfLib_INCLUDE_DIR AND IccProfLib_LIBRARY)
#  add_definitions(-DHAVE_IccProfLib)
#  message(STATUS "found IccProfLib, enabling full ICC profile checking")
#else()
#  message(STATUS "no IccProfLib found, disabled full ICC profile checking")
#  message(VERBOSE "the IccProfLib is available at https://github.com/InternationalColorConsortium/DemoIccMAX")
#endif()



add_subdirectory(lib)
if(STATIC)
    #target_link_libraries(checkit_tiff -static libcheckit_tiff ${PCRE2_POSIX_LIBRARY} ${PCRE2_LIBRARY} libcheckit_tiff Threads::Threads)
    #target_link_libraries(checkit_check_config -static libcheckit_tiff ${PCRE2_POSIX_LIBRARY} ${PCRE2_LIBRARY}  Threads::Threads)
    #target_link_libraries(checkit_tiff_risk -static libcheckit_tiff Threads::Threads)
    message(STATUS "LINKFLAGS: ${PCRE2_STATIC_LDFLAGS}")
    message(STATUS "LIBS: ${PCRE2_STATIC_LIBRARIES}")
    target_link_libraries(checkit_tiff -static  libcheckit_tiff ${PCRE2_STATIC_LDFLAGS} ${PCRE2_STATIC_LIBRARIES} libcheckit_tiff)
    target_link_libraries(checkit_check_config -static libcheckit_tiff ${PCRE2_STATIC_LDFLAGS} ${PCRE2_STATIC_LIBRARIES} )
    target_link_libraries(checkit_tiff_risk -static libcheckit_tiff)
else()
  #target_link_libraries(checkit_tiff ${PCRE2_LIBRARIES}  libcheckit_tiff Threads::Threads)
  #target_link_libraries(checkit_check_config ${PCRE2_LIBRARIES} libcheckit_tiff Threads::Threads)
  #target_link_libraries(checkit_tiff_risk  libcheckit_tiff Threads::Threads)
  target_link_libraries(checkit_tiff ${PCRE2_LDFLAGS} ${PCRE2_LIBRARIES}  libcheckit_tiff)
  target_link_libraries(checkit_check_config ${PCRE2_LDFLAGS} ${PCRE2_LIBRARIES} libcheckit_tiff)
  target_link_libraries(checkit_tiff_risk  libcheckit_tiff)
endif()

install( TARGETS checkit_tiff
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  )
install(DIRECTORY
  ../example_configs
  ../tiffs_should_fail
  ../tiffs_should_pass
  DESTINATION share/checkit_tiff/
  )

file( GLOB README_FILES "../README*" "../FAQ" "../LICENSE" "../TODO" "../BUGS")
install(FILES ${README_FILES} DESTINATION share/checkit_tiff/)

include(FindPerl)
if (PERL_FOUND)
  enable_testing()
  set(T_DIR ${PROJECT_SOURCE_DIR}/../t )
  add_executable(test_stack "../t/01_test_stack.c")
  add_test(NAME 01_test_stack COMMAND test_stack WORKING_DIRECTORY ${T_DIR})
  add_test(NAME 01_grammar      COMMAND ${PERL_EXECUTABLE} -I ${T_DIR} 01_test_grammar.t         WORKING_DIRECTORY  ${T_DIR} )
  add_test(NAME 02_config       COMMAND ${PERL_EXECUTABLE} -I ${T_DIR} 02_test_config_examples.t WORKING_DIRECTORY  ${T_DIR} )

=== src/lib/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9.4)
project (lib_checkit_tiff VERSION 1.1 LANGUAGES C CXX)
set(icc_objects_dir ${CMAKE_CURRENT_BINARY_DIR}/IccProfLib/ )
make_directory (${icc_objects_dir})
include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/validate_icc")
file( GLOB checkit_tiff_SOURCES
        "${PROJECT_SOURCE_DIR}/tagrules/*.c"
        "${PROJECT_SOURCE_DIR}/ifdrules/*.c"
        "${PROJECT_SOURCE_DIR}/messages/*.c"
        "${PROJECT_SOURCE_DIR}/helper/*.c"
        "${PROJECT_SOURCE_DIR}/helper/renderer/*.c"
        "${PROJECT_SOURCE_DIR}/validate_icc/*.c"
        "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
        )


option(BUILD_SHARED_LIBS "Build using shared libraries" ON)


if (RefIccMAX_FOUND)
    set(checkit_tiff_SOURCES "${checkit_tiff_SOURCES};${PROJECT_SOURCE_DIR}/validate_icc/validate_icc_with_IccProfLib.cpp")
endif()

add_library(libcheckit_tiff STATIC
        ${checkit_tiff_SOURCES}
        )
target_include_directories(libcheckit_tiff PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_compile_definitions(libcheckit_tiff PUBLIC __STDC_LIMIT_MACROS __STDC_FORMAT_MACROS)
if (STATIC)
    message(STATUS "linking static")
    target_link_libraries(libcheckit_tiff PRIVATE ${REFICCMAX_STATIC_LIBRARY})
else()
    message(STATUS "linking dynamic")
    target_link_libraries(libcheckit_tiff PRIVATE ${REFICCMAX_STATIC_LIBRARY})
#    target_link_libraries(libcheckit_tiff PRIVATE ${REFICMAX_LIBRARIES})
endif()

=== debian/changelog ===
checkit-tiff (1.4.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.4.4 (Closes: #1050516).

 -- Bastian Germann <bage@debian.org>  Sun, 27 Aug 2023 23:57:43 +0200

checkit-tiff (1.4.3-2) unstable; urgency=medium

  * Team upload.
  * Add missing B-D pkg-config.
  * Fix version string for builds without git.

 -- Bastian Germann <bage@debian.org>  Thu, 24 Aug 2023 15:59:53 +0000

checkit-tiff (1.4.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.4.3.
  * Switch to new upstream repository (Closes: #969162).
  * Update build dependencies (Closes: #1000120).
  * Build in directory "build" as expected by upstream test code.
  * Enforce non-parallel build preventing interference between tests.
  * Disable fortify from hardening feature area due to failing test.
  * Add patch fixing version string for builds outside upstream repository.
  * Bump Standards-Version to 4.6.2.
  * Drop reference to non-existing file from debian/copyright.
  * Add lintian-overrides for grammar.xhtml.

 -- Elias Oltmanns <oltmanns@zib.de>  Wed, 12 Jul 2023 09:56:22 +0200

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,17 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libpcre3-dev
-Standards-Version: 4.6.0
+               dh-cmake,
+               dh-cmake-compat (= 1),
+               pkg-config,
+               libpcre2-dev,
+               libdata-printer-perl,
+               libfile-slurp-perl,
+               libtest-base-perl
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/checkit-tiff
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/checkit-tiff.git
-Homepage: https://github.com/SLUB-digitalpreservation/checkit_tiff
+Homepage: https://git.fsfe.org/art1pirat/checkit_tiff
 Rules-Requires-Root: no
 
 Package: checkit-tiff

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-fortify

%:
	dh $@ --sourcedirectory=src --builddirectory=build \
		--no-parallel --buildsystem=cmake

override_dh_install:
	dh_install
	find debian -name "LICENSE" -delete

## checkit-tiff 1.6.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.9.4)
+cmake_minimum_required (VERSION 3.14)
 project (checkit_tiff)
 include_directories("${PROJECT_SOURCE_DIR}/headers")
 include_directories("${PROJECT_SOURCE_DIR}/lib/include")
@@ -7,6 +7,7 @@
 include(CheckFunctionExists)
 include(CheckIPOSupported)
 include(CheckCCompilerFlag)
+include(CheckPIESupported)
 
 file( GLOB checkit_tiff_SOURCES
   "${PROJECT_SOURCE_DIR}/tagrules/*.c"
@@ -40,18 +41,28 @@
 add_definitions(-D_GNU_SOURCE)
 
 check_ipo_supported(RESULT LTO_IS_SUPPORTED OUTPUT LTO_CHECK_ERROR)
-if (LTO_IS_SUPPORTED)
+if (LTO_IS_SUPPORTED AND NOT CMAKE_C_CLANG_TIDY)
   message(STATUS "IPO / LTO enabled")
   set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
 else()
-  message(STATUS "IPO / LTO unsupported: <${LTO_CHECK_ERROR}>")
+  if (CMAKE_C_CLANG_TIDY)
+    set (LTO_CHECK_ERROR "clang-tidy does not support interprocedural optimization!")
+  endif()
+  message(STATUS "IPO / LTO unsupported: ${LTO_CHECK_ERROR}")
+endif()
+
+check_pie_supported(OUTPUT_VARIABLE output LANGUAGES C)
+if(NOT CMAKE_C_LINK_PIE_SUPPORTED)
+  message(WARNING "PIE is not supported at link time: ${output}.\n"
+          "PIE link options will not be passed to linker.")
+  set(CMAKE_POSITION_INDEPENDENT_CODE FALSE)
 endif()
 
 # add default CFLAGS
 if(CMAKE_COMPILER_IS_GNUCC)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat -Werror=format-security -ffunction-sections -fdata-sections")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat -Werror=format-security -ffunction-sections -fdata-sections")
-set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
+#set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
 endif()
 
 set(CMAKE_OPTIMIZE_DEPENDENCIES TRUE)
@@ -136,7 +147,8 @@
   set(CMAKE_CXX_LINK_EXECUTABLE "${CMAKE_C_LINK_EXECUTABLE} -lnodefs.js -lnoderawfs.js")
 else()
   message(STATUS "enabling relro PIE linker flags")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
+  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
+  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
 endif()
 
 if(STATIC)
@@ -259,9 +271,3 @@
 
 include(FindPerl)
 if (PERL_FOUND)
-  enable_testing()
-  set(T_DIR ${PROJECT_SOURCE_DIR}/../t )
-  add_executable(test_stack "../t/01_test_stack.c")
-  add_test(NAME 01_test_stack COMMAND test_stack WORKING_DIRECTORY ${T_DIR})
-  add_test(NAME 01_grammar      COMMAND ${PERL_EXECUTABLE} -I ${T_DIR} 01_test_grammar.t         WORKING_DIRECTORY  ${T_DIR} )
-  add_test(NAME 02_config       COMMAND ${PERL_EXECUTABLE} -I ${T_DIR} 02_test_config_examples.t WORKING_DIRECTORY  ${T_DIR} )

=== src/lib/CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,7 @@
         "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
         )
 
-
 option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
-
 
 if (RefIccMAX_FOUND)
     set(checkit_tiff_SOURCES "${checkit_tiff_SOURCES};${PROJECT_SOURCE_DIR}/validate_icc/validate_icc_with_IccProfLib.cpp")

=== debian/changelog ===
checkit-tiff (1.6.0-2) unstable; urgency=medium

  * Team upload.
  * d/control: update Build-Depends: pkg-config => pkgconf
  * add d/p/fix-typo.patch

 -- xiao sheng wen <atzlinux@debian.org>  Mon, 25 Aug 2025 15:15:36 +0800

checkit-tiff (1.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.6.0
  * rm d/p/use-type-specialized-ct_readXX-functions.patch, new upstream applied
  * d/copyright: update year info to 2025
  * d/u/metadata: add Bug-Database URL
  * d/rules:
      - use execute_after_dh_install target
      - delete -fortify in export DEB_BUILD_MAINT_OPTIONS
      - remove --buildsystem=cmake in dh options
  * d/control: Bump Standards-Version: 4.7.2, no change need

 -- xiao sheng wen <atzlinux@debian.org>  Fri, 11 Apr 2025 12:05:25 +0800

checkit-tiff (1.4.4-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.

  [ Andreas Metzler ]
  * Team upload.
  * Fix FTBFS with gcc-14 by cherrypicking
    use-type-specialized-ct_readXX-functions.patch from upstream GIT master.
    Closes: #1074877

 -- Andreas Metzler <ametzler@debian.org>  Sat, 10 Aug 2024 11:52:06 +0200

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
                cmake,
                dh-cmake,
                dh-cmake-compat (= 1),
-               pkg-config,
+               pkgconf,
                libpcre2-dev,
                libdata-printer-perl,
                libfile-slurp-perl,
                libtest-base-perl
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/checkit-tiff
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/checkit-tiff.git
 Homepage: https://git.fsfe.org/art1pirat/checkit_tiff

=== debian/watch ===
version=4
opts="mode=git,filenamemangle=s%.*/v(@ANY_VERSION@)$%@PACKAGE@-$1%" \
    https://git.fsfe.org/art1pirat/checkit_tiff.git \
    ^refs/tags/v(\d+(?:\.\d+)*)$
